Index: trunk/src/version/initterm.c
===================================================================
--- trunk/src/version/initterm.c	(revision 46)
+++ 	(revision )
@@ -1,126 +1,0 @@
-/* $Id: initterm.c,v 1.1 1999-05-24 20:20:05 ktk Exp $ */
-
-/*
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
-/*
- * VERSION DLL entry point
- *
- * Copyright 1998 Sander van Leeuwen
- * Copyright 1998 Peter Fitzsimmons
- *
- */
-
-/*-------------------------------------------------------------*/
-/* INITERM.C -- Source for a custom dynamic link library       */
-/*              initialization and termination (_DLL_InitTerm) */
-/*              function.                                      */
-/*                                                             */
-/* When called to perform initialization, this sample function */
-/* gets storage for an array of integers, and initializes its  */
-/* elements with random integers.  At termination time, it     */
-/* frees the array.  Substitute your own special processing.   */
-/*-------------------------------------------------------------*/
-
-
-/* Include files */
-#define  INCL_DOSMODULEMGR
-#define  INCL_DOSPROCESS
-#include <os2.h>
-#include <stdlib.h>
-#include <stdio.h>
-#include <string.h>
-#include <builtin.h>
-#include "misc.h"       /*PLF Wed  98-03-18 23:18:29*/
-
-/*-------------------------------------------------------------------*/
-/* _CRT_init is the C run-time environment initialization function.  */
-/* It will return 0 to indicate success and -1 to indicate failure.  */
-/*-------------------------------------------------------------------*/
-int _CRT_init(void);
-/*-------------------------------------------------------------------*/
-/* _CRT_term is the C run-time environment termination function.     */
-/* It only needs to be called when the C run-time functions are      */
-/* statically linked.                                                */
-/*-------------------------------------------------------------------*/
-void _CRT_term(void);
-void __ctordtorInit( void );
-void __ctordtorTerm( void );
-
-/*-------------------------------------------------------------------*/
-/* A clean up routine registered with DosExitList must be used if    */
-/* runtime calls are required and the runtime is dynamically linked. */
-/* This will guarantee that this clean up routine is run before the  */
-/* library DLL is terminated.                                        */
-/*-------------------------------------------------------------------*/
-static void APIENTRY cleanup(ULONG reason);
-
-
-
-/****************************************************************************/
-/* _DLL_InitTerm is the function that gets called by the operating system   */
-/* loader when it loads and frees this DLL for each process that accesses   */
-/* this DLL.  However, it only gets called the first time the DLL is loaded */
-/* and the last time it is freed for a particular process.  The system      */
-/* linkage convention MUST be used because the operating system loader is   */
-/* calling this function.                                                   */
-/****************************************************************************/
-unsigned long _System _DLL_InitTerm(unsigned long hModule, unsigned long
-                                    ulFlag)
-{
-   size_t i;
-   APIRET rc;
-
-   /*-------------------------------------------------------------------------*/
-   /* If ulFlag is zero then the DLL is being loaded so initialization should */
-   /* be performed.  If ulFlag is 1 then the DLL is being freed so            */
-   /* termination should be performed.                                        */
-   /*-------------------------------------------------------------------------*/
-
-   switch (ulFlag) {
-      case 0 :
-
-         /*******************************************************************/
-         /* The C run-time environment initialization function must be      */
-         /* called before any calls to C run-time functions that are not    */
-         /* inlined.                                                        */
-         /*******************************************************************/
-
-         if (_CRT_init() == -1)
-            return 0UL;
-  	 __ctordtorInit();
-
-         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
-
-         /*******************************************************************/
-         /* A DosExitList routine must be used to clean up if runtime calls */
-         /* are required and the runtime is dynamically linked.             */
-         /*******************************************************************/
-
-         rc = DosExitList(0x0000FF00|EXLST_ADD, cleanup);
-         if(rc)
-		return 0UL;
-
-         break;
-      case 1 :
-         break;
-      default  :
-         return 0UL;
-   }
-
-   /***********************************************************/
-   /* A non-zero value must be returned to indicate success.  */
-   /***********************************************************/
-   return 1UL;
-}
-
-
-static void APIENTRY cleanup(ULONG ulReason)
-{
-   __ctordtorTerm();  
-   _CRT_term();
-   DosExitList(EXLST_EXIT, cleanup);
-   return ;
-}
Index: trunk/src/winmm/initterm.c
===================================================================
--- trunk/src/winmm/initterm.c	(revision 46)
+++ 	(revision )
@@ -1,131 +1,0 @@
-/* $Id: initterm.c,v 1.1 1999-05-24 20:20:05 ktk Exp $ */
-
-/*
- * WINMM DLL entry point
- *
- * Copyright 1998 Sander van Leeuwen (sandervl@xs4all.nl)
- * Copyright 1998 Peter Fitzsimmons
- *
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
-
-/*-------------------------------------------------------------*/
-/* INITERM.C -- Source for a custom dynamic link library       */
-/*              initialization and termination (_DLL_InitTerm) */
-/*              function.                                      */
-/*                                                             */
-/* When called to perform initialization, this sample function */
-/* gets storage for an array of integers, and initializes its  */
-/* elements with random integers.  At termination time, it     */
-/* frees the array.  Substitute your own special processing.   */
-/*-------------------------------------------------------------*/
-
-
-/* Include files */
-#define  INCL_DOSMODULEMGR
-#define  INCL_DOSPROCESS
-#include <os2.h>
-#include <stdlib.h>
-#include <stdio.h>
-#include <string.h>
-#include <builtin.h>
-#include "misc.h"       /*PLF Wed  98-03-18 23:19:26*/
-#include "aux.h"
-
-void IRTMidiShutdown();  // IRTMidi shutdown routine
-
-/*-------------------------------------------------------------------*/
-/* _CRT_init is the C run-time environment initialization function.  */
-/* It will return 0 to indicate success and -1 to indicate failure.  */
-/*-------------------------------------------------------------------*/
-int _CRT_init(void);
-/*-------------------------------------------------------------------*/
-/* _CRT_term is the C run-time environment termination function.     */
-/* It only needs to be called when the C run-time functions are      */
-/* statically linked.                                                */
-/*-------------------------------------------------------------------*/
-void _CRT_term(void);
-void __ctordtorInit( void );
-void __ctordtorTerm( void );
-
-/*-------------------------------------------------------------------*/
-/* A clean up routine registered with DosExitList must be used if    */
-/* runtime calls are required and the runtime is dynamically linked. */
-/* This will guarantee that this clean up routine is run before the  */
-/* library DLL is terminated.                                        */
-/*-------------------------------------------------------------------*/
-static void APIENTRY cleanup(ULONG reason);
-
-
-
-/****************************************************************************/
-/* _DLL_InitTerm is the function that gets called by the operating system   */
-/* loader when it loads and frees this DLL for each process that accesses   */
-/* this DLL.  However, it only gets called the first time the DLL is loaded */
-/* and the last time it is freed for a particular process.  The system      */
-/* linkage convention MUST be used because the operating system loader is   */
-/* calling this function.                                                   */
-/****************************************************************************/
-unsigned long _System _DLL_InitTerm(unsigned long hModule, unsigned long
-                                    ulFlag)
-{
-   size_t i;
-   APIRET rc;
-
-   /*-------------------------------------------------------------------------*/
-   /* If ulFlag is zero then the DLL is being loaded so initialization should */
-   /* be performed.  If ulFlag is 1 then the DLL is being freed so            */
-   /* termination should be performed.                                        */
-   /*-------------------------------------------------------------------------*/
-
-   switch (ulFlag) {
-      case 0 :
-
-         /*******************************************************************/
-         /* The C run-time environment initialization function must be      */
-         /* called before any calls to C run-time functions that are not    */
-         /* inlined.                                                        */
-         /*******************************************************************/
-
-         if (_CRT_init() == -1)
-            return 0UL;
-         __ctordtorInit();
-
-         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
-
-         /*******************************************************************/
-         /* A DosExitList routine must be used to clean up if runtime calls */
-         /* are required and the runtime is dynamically linked.             */
-         /*******************************************************************/
-
-         rc = DosExitList(0x0000FF00|EXLST_ADD, cleanup);
-         if(rc)
-                return 0UL;
-
-         break;
-      case 1 :
-         auxOS2Close(); /* SvL: Close aux device if necessary */
-         break;
-      default  :
-         return 0UL;
-   }
-
-   /***********************************************************/
-   /* A non-zero value must be returned to indicate success.  */
-   /***********************************************************/
-   return 1UL;
-}
-
-
-static void APIENTRY cleanup(ULONG ulReason)
-{
-   auxOS2Close();  /* SvL: Close aux device if necessary */
-   IRTMidiShutdown;  /* JT: Shutdown RT Midi subsystem, if running. */
-   __ctordtorTerm();
-   _CRT_term();
-   DosExitList(EXLST_EXIT, cleanup);
-   return ;
-}
-
Index: trunk/src/winspool/initterm.c
===================================================================
--- trunk/src/winspool/initterm.c	(revision 46)
+++ 	(revision )
@@ -1,126 +1,0 @@
-/* $Id: initterm.c,v 1.1 1999-05-24 20:20:07 ktk Exp $ */
-
-/*
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
-/*
- * WINSPOOL DLL entry point
- *
- * Copyright 1998 Sander van Leeuwen
- * Copyright 1998 Peter Fitzsimmons
- *
- */
-
-/*-------------------------------------------------------------*/
-/* INITERM.C -- Source for a custom dynamic link library       */
-/*              initialization and termination (_DLL_InitTerm) */
-/*              function.                                      */
-/*                                                             */
-/* When called to perform initialization, this sample function */
-/* gets storage for an array of integers, and initializes its  */
-/* elements with random integers.  At termination time, it     */
-/* frees the array.  Substitute your own special processing.   */
-/*-------------------------------------------------------------*/
-
-
-/* Include files */
-#define  INCL_DOSMODULEMGR
-#define  INCL_DOSPROCESS
-#include <os2.h>
-#include <stdlib.h>
-#include <stdio.h>
-#include <string.h>
-#include <builtin.h>
-#include "misc.h"       /*PLF Wed  98-03-18 23:19:26*/
-
-/*-------------------------------------------------------------------*/
-/* _CRT_init is the C run-time environment initialization function.  */
-/* It will return 0 to indicate success and -1 to indicate failure.  */
-/*-------------------------------------------------------------------*/
-int _CRT_init(void);
-/*-------------------------------------------------------------------*/
-/* _CRT_term is the C run-time environment termination function.     */
-/* It only needs to be called when the C run-time functions are      */
-/* statically linked.                                                */
-/*-------------------------------------------------------------------*/
-void _CRT_term(void);
-void __ctordtorInit( void );
-void __ctordtorTerm( void );
-
-/*-------------------------------------------------------------------*/
-/* A clean up routine registered with DosExitList must be used if    */
-/* runtime calls are required and the runtime is dynamically linked. */
-/* This will guarantee that this clean up routine is run before the  */
-/* library DLL is terminated.                                        */
-/*-------------------------------------------------------------------*/
-static void APIENTRY cleanup(ULONG reason);
-
-
-
-/****************************************************************************/
-/* _DLL_InitTerm is the function that gets called by the operating system   */
-/* loader when it loads and frees this DLL for each process that accesses   */
-/* this DLL.  However, it only gets called the first time the DLL is loaded */
-/* and the last time it is freed for a particular process.  The system      */
-/* linkage convention MUST be used because the operating system loader is   */
-/* calling this function.                                                   */
-/****************************************************************************/
-unsigned long _System _DLL_InitTerm(unsigned long hModule, unsigned long
-                                    ulFlag)
-{
-   size_t i;
-   APIRET rc;
-
-   /*-------------------------------------------------------------------------*/
-   /* If ulFlag is zero then the DLL is being loaded so initialization should */
-   /* be performed.  If ulFlag is 1 then the DLL is being freed so            */
-   /* termination should be performed.                                        */
-   /*-------------------------------------------------------------------------*/
-
-   switch (ulFlag) {
-      case 0 :
-
-         /*******************************************************************/
-         /* The C run-time environment initialization function must be      */
-         /* called before any calls to C run-time functions that are not    */
-         /* inlined.                                                        */
-         /*******************************************************************/
-
-         if (_CRT_init() == -1)
-            return 0UL;
-     __ctordtorInit();
-
-         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
-
-         /*******************************************************************/
-         /* A DosExitList routine must be used to clean up if runtime calls */
-         /* are required and the runtime is dynamically linked.             */
-         /*******************************************************************/
-
-         rc = DosExitList(0x0000FF00|EXLST_ADD, cleanup);
-         if(rc)
-        return 0UL;
-
-         break;
-      case 1 :
-         break;
-      default  :
-         return 0UL;
-   }
-
-   /***********************************************************/
-   /* A non-zero value must be returned to indicate success.  */
-   /***********************************************************/
-   return 1UL;
-}
-
-
-static void APIENTRY cleanup(ULONG ulReason)
-{
-   __ctordtorTerm();
-   _CRT_term();
-   DosExitList(EXLST_EXIT, cleanup);
-   return ;
-}